#ifndef CDCOLLISIONENGINE_H
#define CDCOLLISIONENGINE_H

#pragma once
#include <SceneGraph/SGBehaviorEngine.h>
#include <Collision/CDFramePair.h>
#include <Collision/CDDetectorImp.h>
#include <WinBasis/WBPreciseTimer.h>

namespace Spr{;


///	Փˎ̃Xi[(R[obN)NXD
class CDCollisionListener{
public:
	///	ׂĂ̑OɈxĂяoR[obND
	virtual void BeforeAll(SGScene* scene){}

	///	Փ˔C͑OɌĂяoR[obNDڐGĂt[΂̐ĂяoD
	virtual void Before(SGScene* scene, CDFramePairWithRecord* fr){}
	///	͒C̖ʂⒸ_LȂƂɁCڐGĂʌ`΂̐ĂяoR[obND
	virtual void Analyzed(SGScene* scene, CDFramePairWithRecord* fr, CDGeometryPair* geom, CDConvexPairWithRecord* conv, CDContactAnalysis* analyzer){}
	///	͌ɌĂяoR[obNDڐGĂt[΂̐ĂяoD
	virtual void After(SGScene* scene, CDFramePairWithRecord* fr){}

	///	ׂĂ̌ɈxĂяoR[obND
	virtual void AfterAll(SGScene* scene){}
};
///	Xivector
class CDCollisionListeners:public std::vector<CDCollisionListener*>{
public:
	///	Փ˔OɈxĂяoR[obND
	void BeforeAll(SGScene* scene){
		for(unsigned  i=0; i<size(); ++i){
			at(i)->BeforeAll(scene);
		}
	}
	///	Փ˔C͑OɌĂяoR[obNDڐGĂt[΂̐ĂяoD
	void Before(SGScene* scene, CDFramePairWithRecord* fr){
		for(unsigned  i=0; i<size(); ++i){
			if (fr->IsActive(i)) begin()[i]->Before(scene, fr);
		}
	}
	///	͒C̖ʂⒸ_LȂƂɁCڐGĂʌ`΂̐ĂяoR[obND
	void Analyzed(SGScene* scene, CDFramePairWithRecord* fr, CDGeometryPair* geom, CDConvexPairWithRecord* conv, CDContactAnalysis* analyzer){
		for(unsigned  i=0; i<size(); ++i){
			if (fr->IsActive(i)) begin()[i]->Analyzed(scene, fr, geom, conv, analyzer);
		}
	}
	///	͌ɌĂяoR[obNDڐGĂt[΂̐ĂяoD
	void After(SGScene* scene, CDFramePairWithRecord* fr){
		for(unsigned  i=0; i<size(); ++i){
			if (fr->IsActive(i)) begin()[i]->After(scene, fr);
		}
	}
	void AfterAll(SGScene* scene){
		for(unsigned  i=0; i<size(); ++i){
			at(i)->AfterAll(scene);
		}
	}
};

/**	Փ˔GWD
	Փ˂ĂyACՓ˔sCR[obNĂяoD	*/
class CDCollisionEngine: public SGBehaviorEngine
{
protected:
	///	ANeBu^ANeBuȃXi̎w
	struct ActivePair{
		int pos;		///<	Xi̔ԍ
		int frame[2];	///<	t[̃yA
	};
	typedef std::vector<ActivePair> TActivePairs;
	TActivePairs activeList;	///<	Փ˔siXiĂяojyÃXg(ftHgł͍sȂ)
	TActivePairs inactiveList;	///<	Փ˔sȂiXiĂтȂjyÃXg(ftHgł͍s)
	std::vector<bool> defaults;	///<	ftHgŏՓ˔siXiĂяojǂ̃tO
	
	///	Փ˔̈ꗗDitem(i,j) (i<j) ŃANZXD
	CDFramePairWithRecords pairs;
	///	ڐG̓GWD̖ʂⒸ_̏ĂD
	CDContactAnalysis analyzer;
	///	t[Ƃ̃[UR[h̐
	int nFrameRecords;
	///	t[yAƂ̃[UR[h̐
	int nFramePairRecords;
	///	ʌ`̃yAƂ̃[UR[h̐
	int nConvexPairRecords;
	///	Ώۃt[̃Rei^
	typedef std::vector< UTRef<CDFrame> > Frames;
	///	Փ˔Ώۂ̃t[
	Frames frames;
	///	Փ˂̃Xi
	CDCollisionListeners listeners;
	///	t[ƃt[ԍ̑Ή\

	void Render(GRRender* render, SGScene* scene);
	
	std::map<SGFrame*, int> frameMap;

public:
	///	t[΂̂߂̃C^[^
	typedef CDFramePairWithRecords::iterator TFrameIt;

	struct GetGeom{
		CDGeometryPairs* operator()(TFrameIt it){ return *it ? &(*it)->geometryPairs : NULL; }
	};
	///	WIg΂̂߂̃C^[^
	class TGeometryIt: public UTComposedIterator<CDGeometryPair*, TFrameIt, CDGeometryPairs::iterator, GetGeom>{
		friend class CDCollisionEngine;
		friend class TConvexIt;
	public:
		TGeometryIt(){}
		TGeometryIt(CDFramePairWithRecords::iterator b, CDFramePairWithRecords::iterator e, CDGeometryPairs::iterator g){
			Init(b, e, g);
		}
	};

	
	struct GetConv{
		CDConvexPairs* operator()(TGeometryIt it){ return &it->convexPairs; }
	};
	///	ʌ`΂̂߂̃C^[^
	class TConvexIt: public UTComposedIterator<CDConvexPairWithRecord*, TGeometryIt, CDConvexPairs::iterator, GetConv>{
		friend class CDCollisionEngine;
		TConvexIt(){}
		TConvexIt(TGeometryIt b, TGeometryIt e, CDConvexPairs::iterator c){
			Init(b, e, c);
		}
	};

public:
	WBPreciseTimer timerGjk, timerQhull, timerNormal;
	///
	SGOBJECTDEF(CDCollisionEngine);
	///
	CDCollisionEngine();

	///@name	BehaviorEngineI[o[Ch
	//{
	///
	int GetPriority() const { return SGBP_COLLISIONENGINE; }
	///	Ԃ dt i߂
	virtual void Step(SGScene* s);
	///	Ώۂ̃t[NAD
	virtual void Clear(SGScene* s);
	///	(frames  pairs)
	void Init();
	//}

	//@name	Xi┻Ώۂ̃t[Ɗ֘Atꂽf[^̃ANZX
	//@{
	///	XiԂD
	CDCollisionListener* GetListener(int pos){ return listeners[pos]; }
	///	Xi̐
	size_t NListener(){ return listeners.size(); }

	///	t[̔ԍԂD
	int GetFrameID(SGFrame* fr){ return frameMap[fr]; }
	///	t[΂ԂDf1 < f2 łȂ΂ȂȂD
	CDFramePairWithRecord* GetFramePair(int f1, int f2){
		return pairs.item(f1, f2);
	}
	///	t[΂ԂD(f1,f2)(f2,f1)ǂ͌D
	CDFramePairWithRecord* GetFramePair(SGFrame* f1, SGFrame*f2){ return GetFramePair(GetFrameID(f1), GetFrameID(f2)); }
	///	t[IDt[ԂD
	SGFrame* GetFrame(int id){ return frames[id]->frame; }
	///	t[IDƃR[ḧʒu(ReserveFrameRecord()̕Ԃl)烌R[hԂD
	CDUserRecord* GetFrameRecord(int id, int pos){ return frames[id]->records[pos]; }
#if defined _MSC_VER && _MSC_VER >= 1300
	///	t[΂̃C^[^̎n_
	TFrameIt FramePairBegin() const { return (TFrameIt&)pairs.begin(); }
	///	t[΂̃C^[^̏I_
	TFrameIt FramePairEnd() const { return (TFrameIt&)pairs.end(); }
#else
	///	t[΂̃C^[^̎n_
	TFrameIt FramePairBegin() const { return (TFrameIt)pairs.begin(); }
	///	t[΂̃C^[^̏I_
	TFrameIt FramePairEnd() const { return (TFrameIt)pairs.end(); }
#endif
	///	WIg΂̃C^[^̎n_
	TGeometryIt GeometryPairBegin() const{
		TGeometryIt rv;
		rv.InitAsBegin(FramePairBegin(), FramePairEnd());
		return rv;
	}
	///	WIg΂̃C^[^̏I_
	TGeometryIt GeometryPairEnd() const{
		TGeometryIt rv;
		rv.InitAsEnd(FramePairBegin(), FramePairEnd());
		return rv;
	}
	///	ʌ`΂̃C^[^̎n_
	TConvexIt ConvexPairBegin() const {
		TConvexIt rv;
		rv.InitAsBegin(GeometryPairBegin(), GeometryPairEnd());
		return rv;
	}
	///	ʌ`΂̃C^[^̏I_
	TConvexIt ConvexPairEnd() const{
		TConvexIt rv;
		rv.InitAsEnd(GeometryPairBegin(), GeometryPairEnd());
		return rv;
	}
	//}
	
	///@name	o^Cǉñ\bh
	//{
	///	Ώۃt[ǉDׂĂ̔Ώۃt[͓KwɂȂ΂ȂȂD
	void AddFrame(SGFrame* frame, CDUserRecord* rec=NULL, int pos=-1);
	///	t[̐
	size_t NFrame(){ return frames.size(); }
	///	Xi[̓o^
	int AddListener(CDCollisionListener* l);
	///	Փ˔ȂyAo^iftHgł͏Փ˔肷j
	bool AddInactive(int f1, int f2, int pos);
	///	Փ˔ȂyAo^iftHgł͏Փ˔肷j
	bool AddInactive(SGFrame* f1, SGFrame* f2, int pos){ return AddInactive(GetFrameID(f1), GetFrameID(f2), pos); }
	///	pos̃XiɂĔ肵Ȃ悤ɓo^yA(InactiveList)NA
	int ClearInactive(int pos);
	///	Փ˔yAo^ipos ̃XiɂẮCftHgł͔肵ȂȂDj
	bool AddActive(int f1, int f2, int pos);
	///	Փ˔yAo^ipos ̃XiɂẮCftHgł͔肵ȂȂDj
	bool AddActive(SGFrame* f1, SGFrame* f2, int pos){ return AddActive(GetFrameID(f1), GetFrameID(f2), pos); }
	///	pos̃XiɂĔ肷悤ɓo^yA(activeList)NA
	int ClearActive(int pos);
	///	t[(CDFrame) Ƃ̃[UR[h(records) ̏ꏊD
	int ReserveFrameRecord();
	///	t[̃yA(CDFramePairWithRecord) Ƃ̃[UR[h(records) ̏ꏊD
	int ReserveFramePairRecord();
	///	ʌ`̃yA(CDConvexPairWithRecord) Ƃ̃[UR[h̏ꏊD
	int ReserveConvexPairRecord();
	//}

	void RayCheck(Vec3f from, Vec3f dir);
	
	///	Ԃ̓ǂݏo
	virtual void LoadState(const SGBehaviorStates& states);
	///	Ԃ̕ۑ
	virtual void SaveState(SGBehaviorStates& states) const;
};

}

#endif

