// CRBallBalanceQuadPR.h: CRBallBalanceQuadPR NX̃C^[tFCX
//
//////////////////////////////////////////////////////////////////////

#ifndef CRBALLBALANCE_QUADPR_H
#define CRBALLBALANCE_QUADPR_H

#include <Base/QuadProgram.h>
#include <WinBasis/WBPreciseTimer.h>

#include "CRBallBalance.h"

#define ANKLE_NUM	2
#define ANKLE_DOF	6	// ()̎Rx(i3,]3)
#define BALANCE_DOF	6	// oXɕKvȎRx(i3,]3)

namespace Spr{;

class CRVirtualHuman;

class CRBallBalanceQuadPR:public CRBallBalance{

public:
	CRBallBalanceQuadPR();
	virtual ~CRBallBalanceQuadPR();

	// NX̃CX^X
	VQuadProgram<double> quadPR;								// 񎟌v@
	WBPreciseTimer timer;										// Ԍv

	/////// TEST֐&ϐ@////////
	float transTime;	// `dsvZ
	float quadTime;		// 񎟌v@vZ


	//////////@ ֐@@//////////
	// ֐
	bool CompNoJoint(int jointNum,CRBallHuman* crHuman);			// œKŎgȂ֐߂ǂ𔻒f
	void DataOut(CRBallHuman* CRBallHuman);								// t@CɃf[^o

	// ݒ
	void Init(SGScene* scene,CRBallHuman* crHuman);					// 
	void SetBalanceParameter(CRBallHuman* crHuman);					// oXɕKvȃp[^ݒ

	// 񎟌v@ł̃oX
	virtual void ModifyBody(SGScene* scene,CRBallHuman* crHuman);	// oXƂȀ(oXɕKvȏdSgNvZ͕ʁj
	void SetTargetJointTorque(SGScene* scene,CRBallHuman* crHuman);	// e֐߂̖ڕWgN̎擾
	void CalcTransMatrix(SGScene* scene,CRBallHuman* crHuman);		// `dšvZ
	void MakeTorquePattern(CRBallHuman* crHuman, int t);			// `dŝ߂̃gN,̓p^[̐
	Vec3d GetJointAccel(PHJoint1D* joint);						// ֐߂̕ix̎擾
	virtual void SetQuadPR(CRBallHuman* crHuman);							// 񎟌v@̖ړI֐vZ
	void QuadPRSolve();											// 񎟌v@
	void SetBalanceTorque(CRBallHuman* crHuman);					// œK(oX)gN֐߂ɃZbg
	bool BalanceCheck(CRBallHuman* crHuman);
	
	// ŃoXۏ,Ȃ悤ɂ
	virtual void AnkleBalance(CRBallHuman* crHuman);						// 񎟌v@Ŏ肫ȂoX𑫎ŕۏ
	Vec3d AdjustAnkleTorque(CRBallHuman* crHuman,
				Vec3d ankleForce,Vec3d ankleTorque,int ankle);	// Ȃ悤ɃgN𒲐
	bool AnkleZmpCheck(Vec3f zmp,CRSupportArea* supportArea);	// ZMPڐGp`ɂ邩`FbN
	Vec3f CalcPoint(Vec3f p0, Vec3f p1,Vec3f zmp);

	Vec3f GetAnkleRealZmpR(){return ankleRealZmp[0];}
	Vec3f GetAnkleRealZmpL(){return ankleRealZmp[1];}
	Vec3f GetAnkleGoalZmpR(){return ankleGoalZmp[0];}
	Vec3f GetAnkleGoalZmpL(){return ankleGoalZmp[1];}

	void RenewConstraint(CRBallHuman* crHuman);
	void NewConstraint(CRBallHuman* CRBallHuman,PHSolid* heel,Vec3f* maxRange,Vec3f* minRange,int ankleSide);


	// TEST
	void AnkleBalance2(CRBallHuman* CRBallHuman);
	Vec3d AdjustAnkleTorque2(CRBallHuman* crHuman,Vec3d footForce,
							Vec3d footTorque,Vec3d zmp,int ankle);	// Ȃ悤ɃgN𒲐
	Vec3d cog_zmp,footR_zmp,footL_zmp;
	bool bAdjust;

	void OffSpring();

	//////////@ ϐ@@//////////
	unsigned int ankleNum;							// ̐
	unsigned int ankelDof;							// ()̎Rx(i3,]3)
	unsigned int balanceDof;						// oXɕKvȎRx(i3,]3)
	// `ds
	PTM::VMatrixRow<float>	transT;					// e֐߃gN̓`dsT(gN̓`dj
	PTM::VMatrixRow<float>	transF;					// e֐߃gN̓`dsF(͂̓`d)
	PTM::VVector<float>		transM;					// e֐߃gN̓`dsM(ʂ̓`d)
	// 񎟌v@X_cog = tempA*t + tempB
	PTM::VMatrixRow<double> tempA;
	PTM::VVector<float> tempB;
	// e֐߂̖ړIgN(B^̂߂̃gN)
	PTM::VVector<float> targetTorque;				// e֐߂̖ړIgN(t0)
	PTM::VVector<float> targetTorqueP;				// e֐߂̖ړIgN(t0)proportional
	PTM::VVector<float> targetTorqueD;				// e֐߂̖ړIgN(t0)differential
	// 񎟌v@̖ړI֐̌W
	float coefficient;								// oXd or B^d
	float coefficientP;								// ڕWgNPƍœKȃgN̍ŏɂ鍀̌W
	float coefficientD;								// ڕWgNDƍœKȃgN̍ŏɂ鍀̌W
	PTM::VVector<float> coefficientJoint;			// e֐߂̃gN}W(傫Ɨ})

	PTM::TVector<BALANCE_DOF,double> targetX;		// oX̖ڕW
	PTM::VVector<float> optTorque;					// œKgN
	float qdprBalanceRate;							// oXɕKvȃgN̉񎟌v@ŉ
	Vec3f ankleRealZmp[2];							// ̃AZMP
	Vec3f ankleGoalZmp[2];							// ̏ڕWZMP
	unsigned int useJoNum;							// œKŎg֐߂̐
	std::vector<Vec3d> unitVec;						// X,Y,Z̒PʃxNg
	int count;										// 񎟌v@̎s
	
};

}		//	end namespace Spr
#endif // !defined(CRBallBalance_QUADPR_H)
