#ifndef D3RENDER_H
#define D3RENDER_H

#include <Graphics/GRRender.h>
#include <WinBasis/WBUtility.h>
#include <WinBasis/WBCriticalSection.h>
#include <WinDx/D3D/WXD3D.h>


struct TLVertex
{
    float    x, y, z, rhw;
    D3DCOLOR diffuse;    
};

const DWORD VertexFVF = (D3DFVF_XYZRHW | D3DFVF_DIFFUSE);

namespace Spr {;
/**	eNX`t@C̊ǗNXD
	2d[hȂdg݁D*/
class SPR_DLL D3TextureManager{
public:
	class D3Render* render;
	D3TextureManager(){ render = NULL; }
	std::map<UTString, WXINTFV(Direct3DTexture)> textures;
	virtual WXINTFV(Direct3DTexture) Get(UTString filename);
};

/**	OtBbN_Direct3DɂD
*/
class SPR_DLL D3Render:public GRRender{
public:
	SGOBJECTDEF(D3Render);
	///	Direct3DDevice
	WXD3DDevice device;
	///	eNX`Ǘ
	D3TextureManager textureManager;
	///	sX^bN
	UTStack<Affinef> modelMatrixStack;
	/// ̐
	int nLights;

	///	RXgN^	
	D3Render();
	///	
	virtual bool Create(void* arg);
	///	[h̏CGRMeshȂǂD3MeshȂǂ𐶐D
	void Loaded(SGScene* scene);

	///	obt@NA
	virtual void ClearBuffer();

	virtual void ClearColor(float r, float g, float b, float alpha);

	///	obt@̕\
	void Present();
	///	obt@̕\
	void Present(HWND hw);
	///	_O̊JnOɌĂԊ֐
	virtual void BeginScene();
	///	_ȌIɌĂԊ֐
	virtual void EndScene();
	///	^[Qbg̃TCY
	virtual bool Resize(Vec2f size, HWND wnd=NULL);
	///	_̏
	void Setup(Vec2f screen);
	///	T[tF[XEBhE or tXN[̃TCYɍ킹D
	bool FitSurface(HWND hDeviceWnd = NULL);
	///
	bool SetViewport(void* arg);
	///
	bool SetViewport(Vec2f sz, Vec2f pos=Vec2f(), float minZ=0.0f, float maxZ=1.0f);
	///
	bool IsFullscreen(){ return device.IsFullscreen(); }
	void Fullscreen();
	void Window();	
	//	DirectX̃o[WɂAPÏႢ̋z
	///
	HRESULT SetFVF(DWORD fvf);
	//	`
	virtual void MultModelMatrix(const Affinef& afw);
	virtual void PushModelMatrix();
	virtual void PopModelMatrix();
	virtual void SetModelMatrix(const Affinef& afw);
	virtual void DrawDirect(TPrimitiveType ty, Vec3f* begin, Vec3f* end);
	virtual void DrawIndexed(TPrimitiveType ty, size_t* begin, size_t* end, Vec3f* vtx);
	virtual void DrawText(Vec2f pos, FIString str, const GRFont& font);
	virtual Vec2f GetTextExtent(FIString str, const GRFont& font);
	virtual void SetMaterial(const GRMaterialData& m);
	virtual void SetTexture(const char* fn);
	virtual void PushLight(const GRLightData& m);
	virtual void PopLight();
	virtual void SetLineWidth(float w);
	virtual void SetDepthTest(bool b);
	virtual void SetDepthWrite(bool b);
	virtual void SetDepthFunc(TDepthFunc f);
	virtual void SetAlphaMode(TBlendFunc src, TBlendFunc dest);
	virtual bool CanDraw();
	void InitTree(SGFrame* fr, SGScene* scene);

	virtual Vec3f getPointUnderPixel(int x, int y, bool& found, SGScene* scene);


protected:
};

}	//	Spr
#endif
