#ifndef SG_FRAME_H
#define SG_FRAME_H

#include "SGObject.h"

namespace Spr {;
///	oEfBO{bNX̎
class SGBBox{
	Vec3f bboxCenter;	///<	BBox̒S([Jn)
	Vec3f bboxExtent;	///<	BBox̑傫([Jn)
public:
	///	oEfBO{bNX̐ݒ
	void SetBBoxCenterExtent(Vec3f c, Vec3f e){
		bboxCenter = c;
		bboxExtent = e;
	}
	///	oEfBO{bNX̐ݒ
	void SetBBoxMinMax(Vec3f bmin, Vec3f bmax){
		bboxCenter = (bmin+bmax)*0.5f;
		bboxExtent = (bmax-bmin)*0.5f;
	}
	///	oEfBO{bNX̒ǉ
	void AddBBox(Vec3f bmin, Vec3f bmax){
		Vec3f bboxMin = GetBBoxMin();
		Vec3f bboxMax = GetBBoxMax();
		bboxMin.element_min(bmin);
		bboxMax.element_max(bmax);
		SetBBoxMinMax(bboxMin, bboxMax);
	}
	///	S
	Vec3f GetBBoxCenter(){ return bboxCenter; }
	///	傫
	Vec3f GetBBoxExtent(){ return bboxExtent; }
	///	[_
	Vec3f GetBBoxMin(){ return bboxCenter-bboxExtent; }
	///	傫[_
	Vec3f GetBBoxMax(){ return bboxCenter+bboxExtent; }
	///	^ꂽxNgƂ̓ςőƍŏ̓_
	void GetSupport(const Vec3f& dir, float& minS, float& maxS){
		Vec3f ext0( bboxExtent.X(),  bboxExtent.Y(),  bboxExtent.Z());
		Vec3f ext1(-bboxExtent.X(),  bboxExtent.Y(),  bboxExtent.Z());
		Vec3f ext2( bboxExtent.X(), -bboxExtent.Y(),  bboxExtent.Z());
		Vec3f ext3( bboxExtent.X(),  bboxExtent.Y(), -bboxExtent.Z());
		float d = abs(dir*ext0);
		float d1 = abs(dir*ext1);
		if (d < d1) d = d1;
		float d2 = abs(dir*ext2);
		if (d < d2) d = d2;
		float d3 = abs(dir*ext3);
		if (d < d3) d = d3;
		float c = dir * bboxCenter;
		minS = c-d;
		maxS = c+d;
	}
};

class SGFrame;
///	Spr::Frame ̔zD
class SPR_DLL SGFrames:public std::vector< UTRef<SGFrame> >{
public:
};

/**	V[Ot̃C^tF[Xm[hD
	V[Ot̑󂯕tm[hDʒupێD
	̃f[^̃|C^ێD	*/
class SPR_DLL SGFrame: public SGObject, public UTTreeNode<SGFrame, SGFrames>{
public:
	SGOBJECTDEF(SGFrame);
	typedef UTTreeNode<SGFrame, SGFrames> Tree;
protected:
	///	p
	Affinef posture;
public:
	///	oEfBO{bNX
	SGBBox bbox;
	///	t[̒g(qt[͊܂܂Ȃ)
	SGObjects contents;

	///@name V[Ot\̑
	//@{
	///	LĂIuWFNg̐
	virtual size_t NChildObjects();
	///	LĂIuWFNg
	virtual SGObject* ChildObject(size_t i);
	///	qIuWFNg̒ǉ
	virtual bool AddChildObject(SGObject* o, SGScene* s);
	///	qIuWFNg̍폜
	virtual bool DelChildObject(SGObject* o, SGScene* s);

	virtual SGFrame* FindFrame(UTString);

	///	qɂȂ肦IuWFNǧ^̔z
	virtual const UTTypeInfo** ChildCandidates();
	template <class T>
	void FindObject(T*& obj){
		for(unsigned i=0; i<NChildObjects(); ++i){
			obj = DCAST(T, ChildObject(i));
			if (obj) return;
		}
	}
	template <class T> void FindObject(UTRef<T>& obj){
		T* t = &*obj;
		FindObject(t);
		obj = t;
	}


	///	qm[hȂǂׂďD
	void Clear();
	
	///	֘AtꂽdocJ
	virtual void ReleaseDoc(){
		doc = NULL;
		ForEachChild(&SGFrame::ReleaseDoc);
		for(SGObjects::iterator it = contents.begin(); it != contents.end(); ++it){
			(*it)->ReleaseDoc();
		}
	}
	///	m[h̃_v\
	void Print(std::ostream& os) const;
	//@}
	
	///@name p(ʒuC)
	//@{
	const Vec3f& GetPosition(){ return posture.Pos(); }
	Matrix3f GetRotation(){ return posture.Rot(); }
	template<class T> void SetPosition(T p){ posture.Pos() = p; }
	template<class T> void SetRotation(T p){ posture.Rot() = p; }
	///	em[hɑ΂p(ʒuƉ]킷4x4s)ԂD
	const Affinef& GetPosture(){ return posture;}
	/**	em[hɑ΂p(ʒuƉ]킷4x4s)ݒ肷D
		PHSolidgĂƂ́CSGFrame::SetPosture()͎gĂ͂ȂȂD
		CSolidp㏑Ă܂̂ŁD */
	void SetPosture(const Affinef& a){ posture = a; }
	///	[hWnɑ΂p(ʒuƉ]킷4x4s)ԂD
	Affinef GetWorldPosture(){
		Affinef af;
		SGFrame* fr = this;
		while(fr){
			af = fr->posture * af;
			fr = fr->GetParent();
		}
		return af;
	}
	/**	[hWnɑ΂p(ʒuƉ]킷4x4s)ݒ肷D
		PHSolidgĂƂ́CSGFrame::SetPosture()͎gĂ͂ȂȂD
		CSolidp㏑Ă܂̂ŁD */
	void SetWorldPosture(const Affinef& a){
		if (GetParent()){
			posture = GetParent()->GetWorldPosture().inv() * a;
		}else{
			posture = a;
		}
	}
	///	oEfBO{bNX̌vZ
	virtual void CalcBBox();
	///	oEfBO{bNX̗[̎擾
	void GetBBoxSupport(const Vec3f& dir, float& minS, float& maxS){
		bbox.GetSupport(GetPosture().Rot().inv()*dir, minS, maxS);
		float c = GetPosture().Pos() * dir;
		minS += c;
		maxS += c;
	}
	//@}
	///	[hCQƂ̉IĂĂяo֐D
	void Loaded(SGScene* scene);

	///	qt[܂߂āCׂĂContacts񋓂
	void EnumContents(SGObjects& objs);
	void EnumContents(SGObjects& objs, SGFrames& frames);
};

}
#endif
