#ifndef SGSCENE_H
#define SGSCENE_H

#include "SGFrame.h"
#include "SGBehaviorEngine.h"
#include "SGRenderEngine.h"

namespace Spr {;


class SGScene;

class SGObjectNamesLess{
public:
	bool operator () (SGObject* o1, SGObject* o2) const;
};
/**	OƃV[Ot̃IuWFNg̑Ή\
	OL[ɂZbgpӂCÖӐ̕ۏ؂ƃIuWFNg
	D	*/
class SGObjectNames:public std::set<UTRef<SGObject>, SGObjectNamesLess >{
public:
	typedef std::map<UTString, UTString> TNameMap;
	class SGObjectKey:public SGObject{
	public:
		SGObjectKey();
		~SGObjectKey();
		DEF_UTTYPEINFODEF(SGObjectKey);
	};
	TNameMap nameMap;
	static SGObjectKey key;
	void Print(std::ostream& os) const;

	///	OIuWFNg擾
	typedef std::pair<iterator, iterator> range_type;
	SGObject* Find(UTString name, UTString ns="", UTString cn="") const {
		key.name = name;
		key.nameSpace = ns;
		UTString className = cn;
		key.typeInfo.className = className.c_str();
		const_iterator lb = lower_bound(&key);
		if (lb==end()) return NULL;
		SGObjectNamesLess less;
		if (less(*lb, &key)) return NULL;		//	̂Ȃꍇ
		const_iterator it = lb;
		++it;
		if (it == end()) return *lb;
		if(less(&key, *it)) return *lb;		//	̂1
		return NULL;						//	̂Lꍇ
	}
	range_type Range(UTString name, UTString ns="", UTString cn=""){
		key.name = name;
		key.nameSpace = ns;
		UTString className = cn;
		key.typeInfo.className = className.c_str();
		iterator lb = lower_bound(&key);
		if (lb==end()) return range_type(end(), end());
		SGObjectNamesLess less;
		iterator it = lb;
		while(it != end() && !less(*it, &key)){
			++it;
		}
		return range_type(lb, it);
	}
	/**	IuWFNg̒ǉC
		ÔȂIuWFNg͒ǉłȂD̏ꍇ false ԂD
		ǉɐ trueD łɓo^Ăꍇ false ԂD
		OԂꍇ́CǉIuWFNg̖OύXD	*/
	bool Add(SGObject* obj);
	///	IuWFNg̍폜
	bool Del(SGObject* key){
		iterator it = find(key);
		if (it==end()) return false;
		erase(it);
		return true;
	}
	///	IuWFNg̍폜
	bool Del(UTString name){
		SGObject key;
		key.name = name;
		key.AddRef();
		iterator it = find(&key);
		key.DelRef();
		if (it==end()) return false;
		erase(it);
		return true;
	}
};
inline std::ostream& operator << (std::ostream& os, const SGObjectNames& ns){
	ns.Print(os); return os;
}

/**	V[Ot̃gbvm[hDE_D
	_ƃV[Ot̊֌W[߁C
	_ႤƃV[Ot͂̂܂܎gpłȂD
	V[Ot́CƂ΃_OpenGLȂCdisplayList
	Ă邵CD3DȂ ID3DXMeshĂD
	OpenGL̃V[OtD3Dɕϊ邽߂ɂ́CxDocument
	Z[uāCD3D`Ń[hȂ΂ȂȂD	*/
class SPR_DLL SGScene:public SGObject{
	SGOBJECTDEF(SGScene);
protected:
	///	OƃIuWFNg̑Ή\	
	SGObjectNames names;
	///	rwCrAGW
	SGBehaviorEngines behaviors;
	///	_OGW
	SGRenderEngines renderers;
	///	gbvt[
	UTRef<SGFrame> world;
	/// ϕXebv
	double timeStep;
	/// ϕ
	unsigned int count;
	///	1Xebv̑x̌DŜ悤ɓD傫ƔSɂȂD
	double velocityLossPerStep;
public:
	///	RXgN^
	SGScene();
	///	fXgN^
	~SGScene(){Clear();}
	///	rwCrAGW vector ԂD
	SGBehaviorEngines& GetBehaviors(){ return behaviors; }
	const SGBehaviorEngines& GetBehaviors() const { return behaviors; }
	///	_OGW vector ԂD
	SGEngines& GetRenderers(){
		return renderers;
	}

	///	gbvt[ԂD
	SGFrame* GetWorld(){ return world; }
	///	OIuWFNg擾
	SGObject* FindObject(UTString name, UTString ns=""){ return names.Find(name, ns); }
	///	^ƖOIuWFNg擾
	template <class T> void FindObject(UTRef<T>& t, UTString name, UTString ns=""){
		T* p;
		FindObject(p, name, ns);
		t = p;
	}
	template <class T> void FindObject(T*& t, UTString name, UTString ns=""){
		SGObject* p = names.Find(name, ns, GETCLASSNAMES(T));
		t = DCAST(T, p);
	}
	typedef SGObjectNames::iterator SetIt;
	typedef std::pair<SetIt, SetIt> SetRange;
	SetRange RangeObject(UTString n){ return names.Range(n); }
	
	SGObjectNames::TNameMap& GetNameMap(){ return names.nameMap; }

	/// ϕXebvԂ
	double GetTimeStep()const{return timeStep;}
	/// ϕXebvݒ肷
	void SetTimeStep(double dt);
	///	1Xebv̌̎擾
	double GetVelocityLossPerStep(){ return velocityLossPerStep; }
	///	̎擾
	double GetVelocityLoss();
	///	̐ݒ
	void SetVelocityLoss(double dt);
	/// JEgԂ
	unsigned GetCount()const{return count;}
	/// JEgݒ肷
	void SetCount(unsigned c){count = c;}
	///	V[̎i߂ ClearForce(); GenerateForce(); Integrate(); Ɠ
	void Step();
	///	V[̎i߂i͂̃NAj
	void ClearForce();
	///	V[̎i߂i͂̐j
	void GenerateForce();
	///	V[̎i߂i͂ƑxϕāCxƈʒuXVj
	void Integrate();
	///	_O
	void Render();
	///	[hCQƂ̉IĂĂяo֐DeIuWFNgLoadedĂяoD
	void Loaded(SGScene* scene);
	///	V[ɂD
	void Clear();
	///	O\CQƂĂȂIuWFNg폜D
	void ClearName();
	///	fobOp
	void Print(std::ostream& os) const { names.Print(os); }
	///	LĂIuWFNg̐
	virtual size_t NChildObjects();
	///	LĂIuWFNg
	virtual SGObject* ChildObject(size_t i);
	///	qIuWFNg̒ǉ
	virtual bool AddChildObject(SGObject* o, SGScene* s);
	///	qIuWFNg̍폜
	virtual bool DelChildObject(SGObject* o, SGScene* s);
	///	qɂȂ肦IuWFNǧ^̔z
	virtual const UTTypeInfo** ChildCandidates();

	///	Ԃ̓ǂݏo
	virtual void LoadState(const SGBehaviorStates& states);
	///	Ԃ̕ۑ
	virtual void SaveState(SGBehaviorStates& states) const;
protected:
//	friend class SGFrame;
	friend class SGObject;
};

}
#endif
